package com.wms_main.model.vo.wms;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.wms_main.model.po.TAppTaskBak;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;

/**
 * 任务记录Vo
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class TaskRecordVo {
    /**
     * 任务ID
     */
    @JsonProperty("taskId")
    private String taskId;
    /**
     * 任务类型
     */
    @JsonProperty("taskType")
    private Integer taskType;
    /**
     * 任务状态
     */
    @JsonProperty("taskStatus")
    private Integer taskStatus;
    /**
     * 任务优先级
     */
    @JsonProperty("taskPriority")
    private Integer taskPriority;
    /**
     * 载具号
     */
    @JsonProperty("vehicleId")
    private String vehicleId;
    /**
     * 起点
     */
    @JsonProperty("origin")
    private String origin;
    /**
     * 终点
     */
    @JsonProperty("destination")
    private String destination;
    /**
     * wcs任务id
     */
    @JsonProperty("wcsTaskId")
    private String wcsTaskId;
    /**
     * 创建时间
     */
    @JsonProperty("createTime")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime createTime;
    /**
     * 完成时间
     */
    @JsonProperty("finishTime")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime finishTime;
    /**
     * 料号
     */
    @JsonProperty("goodsId")
    private String goodsId;
    /**
     * 操作数量
     */
    @JsonProperty("opNum")
    private Integer opNum;
    /**
     * 库存数量
     */
    @JsonProperty("stockNum")
    private Integer stockNum;
    /**
     * 操纵用户
     */
    @JsonProperty("opUser")
    private String opUser;
    /**
     * 备注
     */
    @JsonProperty("remark")
    private String remark;
    /**
     * 申请出库的站台
     */
    @JsonProperty("callStand")
    private String callStand;
    /**
     * 物料描述
     */
    @JsonProperty("goodsDesc")
    private String goodsDesc;

    /**
     * 将po转换为vo
     * @param po po对象
     * @return vo对象
     */
    public static TaskRecordVo of(TAppTaskBak po) {
        if (po == null) {
            return new TaskRecordVo();
        }
        return new TaskRecordVo(
                po.getTaskId(),
                po.getTaskType(),
                po.getTaskStatus(),
                po.getTaskPriority(),
                po.getVehicleId(),
                po.getOrigin(),
                po.getDestination(),
                po.getWcsTaskId(),
                po.getCreateTime(),
                po.getFinishTime(),
                po.getGoodsId(),
                po.getOpNum(),
                po.getStockNum(),
                po.getOpUser(),
                po.getRemark(),
                po.getCallStand(),
                po.getGoodsDesc()
        );
    }
}
